/* @(#) $Id: rpc.h 1028 2014-01-13 01:16:53Z leres $ (LBL) */
#ifndef acld_rpc_h
#define acld_rpc_h

#include <libxml/parser.h>
#include <libxml/tree.h>

#define ISXMLTAG(s, t) \
    (strncmp((s), (t), sizeof(t) - 1) == 0)

#define ISXMLCOMMENT(s) \
    ISXMLTAG(s, xml_comment)

#define ISXML_ELEMENT(p) \
    ((p) != NULL && (p)->type == XML_ELEMENT_NODE && (p)->name != NULL)

#define ISXML_ELEMENT_NAMED(p, s) \
    (ISXML_ELEMENT(p) && strcmp((const char *)((p)->name), (s)) == 0)

#define ISXML_TEXT(p) \
    ((p) != NULL && (p)->content != NULL && (p)->type == XML_TEXT_NODE)

extern const char *rpc_process(struct state *, struct client *, struct req *,
    xmlNode *);
#endif
